Package com.io7m.cedarbridge.schema.ast

# Record Class CBASTTypeRecord

java.lang.Object
java.lang.Record
com.io7m.cedarbridge.schema.ast.CBASTTypeRecord

Record Components:
  `documentations` - The documentation elements
  `fields` - The record fields
  `lexical` - The lexical info
  `name` - The type name
  `parameters` - The type parameters
  `userData` - The user data

All Implemented Interfaces:
  `CBASTDeclarationType`, `CBASTElementType`, `CBASTTypeDeclarationType`, `com.io7m.jlexing.core.LexicalType<URI>`

public record CBASTTypeRecord(CBASTMutableUserData userData, com.io7m.jlexing.core.LexicalPosition<URI> lexical, CBASTTypeName name, List<CBASTDocumentation> documentations, List<CBASTTypeParameterName> parameters, List<CBASTField> fields) extends Record implements CBASTTypeDeclarationType
A record declaration.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CBASTTypeRecord(CBASTMutableUserData userData, com.io7m.jlexing.core.LexicalPosition<URI> lexical, CBASTTypeName name, List<CBASTDocumentation> documentations, List<CBASTTypeParameterName> parameters, List<CBASTField> fields)`
  A record declaration.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<CBASTDocumentation>`
  `documentations()`
  Returns the value of the `documentations` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `List<CBASTField>`
  `fields()`
  Returns the value of the `fields` record component.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `com.io7m.jlexing.core.LexicalPosition<URI>`
  `lexical()`
  Returns the value of the `lexical` record component.
  `CBASTTypeName`
  `name()`
  Returns the value of the `name` record component.
  `List<CBASTTypeParameterName>`
  `parameters()`
  Returns the value of the `parameters` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `CBASTMutableUserData`
  `userData()`
  Returns the value of the `userData` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CBASTTypeRecord

    public CBASTTypeRecord(CBASTMutableUserData userData, com.io7m.jlexing.core.LexicalPosition<URI> lexical, CBASTTypeName name, List<CBASTDocumentation> documentations, List<CBASTTypeParameterName> parameters, List<CBASTField> fields)
    A record declaration.
    Parameters:
      `documentations` - The documentation elements
      `fields` - The record fields
      `lexical` - The lexical info
      `name` - The type name
      `parameters` - The type parameters
      `userData` - The user data

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### userData

    public CBASTMutableUserData userData()
    Returns the value of the `userData` record component.
    Specified by:
      `userData` in interface `CBASTElementType`
    Returns:
      the value of the `userData` record component

  - ### lexical

    public com.io7m.jlexing.core.LexicalPosition<URI> lexical()
    Returns the value of the `lexical` record component.
    Specified by:
      `lexical` in interface `CBASTElementType`
    Specified by:
      `lexical` in interface `com.io7m.jlexing.core.LexicalType<URI>`
    Returns:
      the value of the `lexical` record component

  - ### name

    public CBASTTypeName name()
    Returns the value of the `name` record component.
    Specified by:
      `name` in interface `CBASTTypeDeclarationType`
    Returns:
      the value of the `name` record component

  - ### documentations

    public List<CBASTDocumentation> documentations()
    Returns the value of the `documentations` record component.
    Specified by:
      `documentations` in interface `CBASTTypeDeclarationType`
    Returns:
      the value of the `documentations` record component

  - ### parameters

    public List<CBASTTypeParameterName> parameters()
    Returns the value of the `parameters` record component.
    Specified by:
      `parameters` in interface `CBASTTypeDeclarationType`
    Returns:
      the value of the `parameters` record component

  - ### fields

    public List<CBASTField> fields()
    Returns the value of the `fields` record component.
    Returns:
      the value of the `fields` record component